using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

namespace WK_KLI_LAPS_Service.Controllers.Master.MailField
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class MailFieldApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private IMailFieldService _MailFieldervices;
        public MailFieldApiController(IMailFieldService MailFieldServices)
        {
            _MailFieldervices = MailFieldServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _MailFieldervices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveMailField")]
        //Code to retrieve active data
        public IActionResult GetActiveMailField()
        {
            var _list = _MailFieldervices.GetActiveMailField();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] mailfieldModel omailfieldModel)
        {

            int retval = 0;
            try
            {
                retval = _MailFieldervices.Add(omailfieldModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] mailfieldModel omailfieldModel)
        {
            int retval = 0;
            try
            {
                retval = _MailFieldervices.Edit(omailfieldModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] mailfieldModel omailfieldModel)
        {
            int retval = 0;
            try
            {
                retval = _MailFieldervices.Delete(omailfieldModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}